﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HEAL.Attic;
using HeuristicLab.Core;

namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
  [StorableType("2bab7669-028a-4ba8-9c63-60853e15ad47")]
  public interface ISingleObjectiveSolutionScope<TSolution> : IScope {
    TSolution Solution { get; set; }
    double Fitness { get; set; }
  }
  [StorableType("0ae52e60-5ea1-428f-99ca-b7b84a79857d")]
  public interface IContext : IExecutionContext {
    new IExecutionContext Parent { get; set; }
    int Iterations { get; set; }
    int EvaluatedSolutions { get; set; }
    double BestQuality { get; set; }

    event EventHandler BestQualityChanged;
  }
  [StorableType("ab766d45-2dab-4280-9f4e-1531fe9a91cf")]
  public interface IStochasticContext : IContext {
    IRandom Random { get; set; }
  }
}
